
From: Sean Hefty <sean.hefty@intel.com>

Replace the *wc field in ib_mad_recv_wc from pointing to a structure on the
stack to one allocated with the received MAD buffer.  This allows a client to
access the *wc field after their receive completion handler has returned.

Signed-off-by: Sean Hefty <sean.hefty@intel.com>
Signed-off-by: Roland Dreier <roland@topspin.com>
Signed-off-by: Andrew Morton <akpm@osdl.org>
---

 25-akpm/drivers/infiniband/core/mad.c      |    3 ++-
 25-akpm/drivers/infiniband/core/mad_priv.h |    1 +
 2 files changed, 3 insertions(+), 1 deletion(-)

diff -puN drivers/infiniband/core/mad.c~ib-keep-mad-work-completion-valid drivers/infiniband/core/mad.c
--- 25/drivers/infiniband/core/mad.c~ib-keep-mad-work-completion-valid	Fri Apr  1 13:53:33 2005
+++ 25-akpm/drivers/infiniband/core/mad.c	Fri Apr  1 13:53:33 2005
@@ -1600,7 +1600,8 @@ static void ib_mad_recv_done_handler(str
 			 DMA_FROM_DEVICE);
 
 	/* Setup MAD receive work completion from "normal" work completion */
-	recv->header.recv_wc.wc = wc;
+	recv->header.wc = *wc;
+	recv->header.recv_wc.wc = &recv->header.wc;
 	recv->header.recv_wc.mad_len = sizeof(struct ib_mad);
 	recv->header.recv_wc.recv_buf.mad = &recv->mad.mad;
 	recv->header.recv_wc.recv_buf.grh = &recv->grh;
diff -puN drivers/infiniband/core/mad_priv.h~ib-keep-mad-work-completion-valid drivers/infiniband/core/mad_priv.h
--- 25/drivers/infiniband/core/mad_priv.h~ib-keep-mad-work-completion-valid	Fri Apr  1 13:53:33 2005
+++ 25-akpm/drivers/infiniband/core/mad_priv.h	Fri Apr  1 13:53:33 2005
@@ -69,6 +69,7 @@ struct ib_mad_list_head {
 struct ib_mad_private_header {
 	struct ib_mad_list_head mad_list;
 	struct ib_mad_recv_wc recv_wc;
+	struct ib_wc wc;
 	DECLARE_PCI_UNMAP_ADDR(mapping)
 } __attribute__ ((packed));
 
_
